package com.test;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpServletResponseWrapper;

public class TestResponse extends HttpServletResponseWrapper {

	ByteArrayOutputStream bout = new ByteArrayOutputStream();

	private boolean outputStreamUsed = false;

	private StringWriter sw = new StringWriter();

	private boolean writerUsed = false;

	public TestResponse(HttpServletResponse response) {
		super(response);
	}

	public ByteArrayOutputStream getBout() {
		return bout;
	}

	@Override
	public ServletOutputStream getOutputStream() throws IOException {
		if (writerUsed) {
			throw new RuntimeException("Writer already used");
		}
		outputStreamUsed = true;
		return new ServletOutputStream() {

			@Override
			public void write(int arg0) throws IOException {
				bout.write(arg0);
			}
		};
	}

	public StringWriter getSw() {
		return sw;
	}

	@Override
	public PrintWriter getWriter() throws IOException {
		if (outputStreamUsed) {
			throw new RuntimeException("OutputStream already used");
		}
		writerUsed = true;
		return new PrintWriter(sw);
	}

	public boolean isOutputStreamUsed() {
		return outputStreamUsed;
	}

	public boolean isWriterUsed() {
		return writerUsed;
	}
}
